/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.session;

import org.apache.logging.log4j.LogManager;import org.apache.logging.log4j.Logger;

import eu.etaxonomy.cdm.api.application.CdmApplicationRemoteController;
import eu.etaxonomy.cdm.api.application.CdmApplicationState;
import eu.etaxonomy.cdm.model.NewEntityListener;
import eu.etaxonomy.cdm.model.common.CdmBase;

/**
 * @author cmathew
 * @date 30 Sep 2015
 */
public class DefaultNewEntityListener implements NewEntityListener {

    private static final Logger logger = LogManager.getLogger(DefaultNewEntityListener.class);

    @Override
    public void onCreate(CdmBase cdmBase) {
        logger.info("New Entity created : " + cdmBase);
        if(CdmApplicationState.getCurrentAppConfig() instanceof CdmApplicationRemoteController){
            ICdmEntitySession activeSession = ((CdmApplicationRemoteController)CdmApplicationState.getCurrentAppConfig()).getCdmEntitySessionManager().getActiveSession();
            if(activeSession != null) {
                activeSession.addNewCdmEntity(cdmBase);
            }
        }
    }
}
