/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.session.mock;

import java.util.Collection;
import java.util.List;
import java.util.UUID;

import eu.etaxonomy.cdm.api.service.IService;
import eu.etaxonomy.cdm.api.service.UpdateResult;
import eu.etaxonomy.cdm.cache.EntityCacherDebugResult;
import eu.etaxonomy.cdm.model.common.CdmBase;
import eu.etaxonomy.cdm.persistence.dto.MergeResult;
import eu.etaxonomy.taxeditor.session.ICdmEntitySession;
import eu.etaxonomy.taxeditor.session.ICdmEntitySessionEnabled;
import net.sf.ehcache.statistics.FlatStatistics;

/**
 * @author cmathew
 * @date 29 Jan 2015
 */
public class MockCdmEntitySession implements ICdmEntitySession  {

    @Override
    public <O extends Object> O load(O obj, boolean update) {
        return obj;
    }

    @Override
    public  <T extends CdmBase> T load(T cdmBase, boolean update) {
        return cdmBase;
    }

    @Override
    public  <T extends CdmBase> Collection<T> load(Collection<T> cdmBaseList, boolean update) {
        return cdmBaseList;
    }

    @Override
    public void setEntitiesAsLatest() {
    }

    @Override
    public void dispose() {
    }

    @Override
    public void bind() {
    }

    @Override
    public  <T extends CdmBase> EntityCacherDebugResult debug(T cdmBase) {
        return new EntityCacherDebugResult();
    }


    @Override
    public <T extends CdmBase> T remoteLoad(IService<T> service, UUID uuid) {
        return service.load(uuid);
    }

    @Override
    public <T extends CdmBase> T remoteLoad(IService<T> service, UUID uuid, List<String> propertyPaths) {
        return service.load(uuid, propertyPaths);
    }

    @Override
    public <T extends CdmBase> UUID remoteSave(IService<T> service, T cdmBase) {
        return service.save(cdmBase).getUuid();
    }

    @Override
    public <T extends CdmBase> T remoteUpdate(IService<T> service, T cdmBase) {
        return cdmBase;
    }

    @Override
    public ICdmEntitySessionEnabled getOwner() {
        return null;
    }

    @Override
    public FlatStatistics getCacheStatistics() {
        return null;
    }

    @Override
    public boolean isActive() {
        return false;
    }

    @Override
    public <T extends CdmBase> List<T> getRootEntities() {
        return null;
    }

    @Override
    public <T extends CdmBase> EntityCacherDebugResult debug(Collection<T> cdmBase, boolean includeIgnored) {
        return null;
    }

    @Override
    public <T extends CdmBase> EntityCacherDebugResult debug(boolean includeIgnored) {
        return null;
    }

    @Override
    public <T extends CdmBase> void update() {
    }

    @Override
    public UpdateResult load(UpdateResult updateResult, boolean update) {
        return updateResult;
    }

    @Override
    public List<String> getPropertyPaths(Object obj) {
        return null;
    }

    @Override
    public void addNewCdmEntity(CdmBase newEntity) {
    }

    @Override
    public <T extends CdmBase> MergeResult<T> load(MergeResult<T> mergeResult, boolean update) {
        return mergeResult;
    }
}