/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.session.mock;

import java.util.Collection;

import eu.etaxonomy.cdm.api.service.UpdateResult;
import eu.etaxonomy.cdm.model.common.CdmBase;
import eu.etaxonomy.cdm.model.common.ICdmBase;
import eu.etaxonomy.cdm.persistence.dto.MergeResult;
import eu.etaxonomy.taxeditor.session.ICdmEntitySession;
import eu.etaxonomy.taxeditor.session.ICdmEntitySessionEnabled;
import eu.etaxonomy.taxeditor.session.ICdmEntitySessionManager;
import eu.etaxonomy.taxeditor.session.ICdmEntitySessionManagerObserver;

public class MockCdmEntitySessionManager implements ICdmEntitySessionManager {

	@Override
	public void bind(ICdmEntitySessionEnabled sessionOwner) {
	}

	@Override
	public <T> T load(T obj, boolean update) {
		return obj;
	}

	@Override
	public <T extends CdmBase> T load(T obj, boolean update) {
		return obj;
	}

	@Override
	public <T extends CdmBase> Collection<T> load(Collection<T> cdmBaseList, boolean update) {
		return cdmBaseList;
	}

    @Override
    public ICdmEntitySession newSession(ICdmEntitySessionEnabled sessionOwner, boolean setAsActive) {
        return new MockCdmEntitySession();
    }

    @Override
    public ICdmEntitySession getActiveSession() {
        return new MockCdmEntitySession();
    }

    @Override
    public Collection<ICdmEntitySession> getSessions() {
        return null;
    }

    @Override
    public void addSessionObserver(ICdmEntitySessionManagerObserver sessionObserver) {

    }

    @Override
    public boolean isRemoting() {
        return false;
    }

    @Override
    public void dispose(ICdmEntitySessionEnabled owner) {
    }

    @Override
    public void disposeAll() {
    }

    @Override
    public <T extends CdmBase> void update() {
    }

    @Override
    public UpdateResult load(UpdateResult updateResult, boolean update) {
        return updateResult;
    }

    @Override
    public boolean contains(ICdmEntitySessionEnabled sessionOwner) {
        return false;
    }

    @Override
    public ICdmEntitySession bindNullSession() {
        return new MockCdmEntitySession();
    }

    @Override
    public ICdmEntitySession getNullSession() {
        return new MockCdmEntitySession();
    }

    @Override
    public <T extends ICdmBase> MergeResult<T> load(MergeResult<T> mergeResult, boolean update) {
        return mergeResult;
    }
}